#include <alloc.h>
#include <mem.h>
#include <string.h>
#include <stdio.h>
#include "enlace.h"

// Nmero de entradas para la tabla hash de mquinas
#define TAM_HASH 13
// Maxima informacin permitida para ser enviada en un paquete
#define TAM_MAX_INFO 1000
// Tamao mximo que puede tener el nombre lgico de una mquina
#define TAM_MAX_NOMBRE_LOG 10
// Desplazamiento que posee la variable 'num_pq' dentro de la
// estructura t_datagrama.
#define DESPL_NUM_PQ (2 * TAM_MAX_NOMBRE + sizeof (unsigned long))

// Informacin de un paquete en el nivel de red
typedef struct tipo_datagrama {
	char logico_og[TAM_MAX_NOMBRE_LOG],  // Nombre lgico origen
		 logico_dt[TAM_MAX_NOMBRE_LOG];  // Nombre lgico destino
	unsigned long pq_total,              // Paquetes totales
				  num_pq;                // Nmero del paquete
	long flags;							 // flags funcionales
	int tam_dat;				         // Nmero de bytes de los datos
	int aux1, aux2;						 // Variables auxiliares
} t_datagrama;


// tipo para la tabla de maquinas
typedef struct tipo_maquina{
		 char logico[TAM_MAX_NOMBRE_LOG]; // Nombre lgico de la mquina
		 char fisico[TAM_DIR];            // Direccin fsica de la maq.
		 struct tipo_maquina *siguiente;  // Puntero a la siguiente maq.
} t_maquina;


// tipo para la cola de paquetes
typedef struct tipo_paquete {
   char dir_fis_dest [TAM_DIR];  // Direccin fisica origen
   char dir_fis_orig [TAM_DIR];  // Direccin fisica destino
   int tipo;					 // Tipo de la interfaz a nivel de enlace
   t_datagrama datag;			 // Datagrama
   char datos [TAM_MAX_TRAMA - TAM_DIRS_TIPO - sizeof(t_datagrama)];
   // Informacin de niveles superiores
} t_paquete;


int f_hash(char cadena[]);
int anadir_maquina(char logico[], char fisico[]);
int buscar_maquina(char *nombre_logico, char *dir_fis);
int comprueba_maquina (char *nombre_logico, char *dir_fis, int insertar);
int elimina_maquina (char *nombre_logico);
int cambiar_dir_fis (char logico[], char fisico[]);
char *construye_paq (t_datagrama datagrama, char *datos, int *tam_paq);
int enviar_paq_constr (char *buffer, int len);
void enviar_paq (t_datagrama datagrama, char *datos);
int sacar_paq (t_paquete *paquete);


extern t_maquina *red[TAM_HASH];   // tabla de maquinas conectadas