#include <time.h>
#include <fcntl.h>
#include <io.h>
#include <math.h>
#include <sys/stat.h>
#include "ftp.h"

#define TIPO 83


void subiendo_fichero(t_paquete *paquete);

t_usuario d_cliente;                // Datos del usuario
char servidor [TAM_MAX_NOMBRE_LOG];	// nombre lgico del servidor
char fichero [20];		            // nombre del fichero a subir o bajar
int num_cliente = -1;               // Nmero del cliente (posicin que
									// ocupa en la tabla de usuarios del
									// servidor.

/************************************************************************/
int Inicializar(void) {
struct REGPACK reg;
int handle,
	i;

 /* almacenamos el tipo */
  tipo = (char *) malloc(TAM_TIPO);
  memset(tipo, TIPO, TAM_TIPO);		/* el tipo 0x01, 0x01 da problemas */

  if ( driver_info(&reg) == -1)
	  error(&reg);

   /* obtenemos nuestra direccion y la guardamos en dir_origen */


  handle = access_type (HI(reg.r_cx), reg.r_dx, LO(reg.r_cx),
						tipo, TAM_TIPO, (void interrupt *)receiver, &reg);

	if (handle == -1)
	  error(&reg);

  if (get_address(handle,dir_origen,TAM_DIR, &reg) == -1)
	 error(&reg);

  /* handle, mode */
  if (set_rcv_mode(handle, 3, &reg) == -1)
	 error(&reg);

  clrscr();
  printf(" Introduzca su nombre: ");
  scanf("%s", d_cliente.n_logico);

  //  anadir_maquina(nombre_cliente, dir_origen);
  d_cliente.estado = E_DESCONECTADO;
  d_cliente.tiempo_ultima_operacion = time (NULL);
  d_cliente.directorio_actual[0] = '\0';

  for (i = 0; i < NUM_MAX_TRAMAS; i++)
	 buffer_entr [i].libre = 1;

  return (handle);
}


/*************************************************************************/
t_datagrama enviar_paquete_mensaje (char *dir_logica_dest, char *mensaje,
							 int tam_mensaje, int flag, int num_cliente){

	t_datagrama datagrama;

	strcpy (datagrama.logico_og, d_cliente.n_logico);
	strcpy (datagrama.logico_dt, dir_logica_dest);
	datagrama.flags = flag;
	datagrama.pq_total = 1;
	datagrama.num_pq = 1;
	datagrama.tam_dat = tam_mensaje;
	datagrama.aux1 = num_cliente;
	enviar_paq (datagrama, mensaje);
	return (datagrama);
}


/*************************************************************************/
int esperar_paquete_con_mascara (t_datagrama datagrama, char *mensaje,
								 t_paquete *paq_recibido, long mascara) {

	int hay_paq;
	double dif_tiempo;
	time_t tiempo_inicio,
		   tiempo_actual;

	d_cliente.iteracion_abortar = ITERACIONES_ABORTAR;
	do {
	   tiempo_inicio = time (NULL);
	   dif_tiempo = 0;
	   hay_paq = sacar_paq (paq_recibido);

	   while ((dif_tiempo < QUANTUM_ESPERA_UN_PAQ) && (!hay_paq)) {
		  hay_paq = sacar_paq (paq_recibido);
		  tiempo_actual = time (NULL);
		  dif_tiempo = difftime (tiempo_actual, tiempo_inicio);
	   }

	   if (hay_paq)
		  if (!(paq_recibido->datag.flags & mascara))
				hay_paq = 0;
		  else
			 break;

	   if (!(d_cliente.iteracion_abortar--))
		  break;

	   enviar_paq (datagrama, mensaje);

	} while (!hay_paq);

	return (hay_paq);
}

/************************************************************************
Funcion que realiza la accion correspondiente con el paquete recibido
segn el comando en el campo de flags.
*************************************************************************/
void tratar_paquete(t_paquete *paquete) {

//  int i,
//	   no_todos_enviados;
//  t_ventana ventana_actual, nueva_ventana;
//  long int num_paquetes;		// n de paquetes totales
//  long int actual;			// n de paquete actual
//  int fd;



  if (paquete->datag.flags & R_MAQ_DESC) {
	 // servidor desconocido
	 // la direccion origen est a partir de la posicion 6 del paquete
	 comprueba_maquina (paquete->datag.logico_og, paquete->dir_fis_orig, 1);
	 num_cliente = paquete->datag.aux1;
  }
/*  else if (datagrama.flags & R_DIR) {
	 // listado del servidor
	 // mostramos los datos
	 printf("%s", paquete->datos);
	 for (i = 2; i <= datagrama.PQ_total; i++) {
		while ((aux = pop()) == NULL)
		   ;
		printf("%s", aux->datos+14+sizeof(t_datagrama));
	 }
*/  else if (paquete->datag.flags & R_CD)
	   printf("Directorio remoto actual: %s\n", paquete->datos);

   else if (paquete->datag.flags & R_SUBIENDO)
	   subiendo_fichero (paquete);


/*recibir
	 num_paquetes = datagrama.PQ_total;
	 _fmode = O_BINARY;
	 fd = creat(fichero, S_IREAD |S_IWRITE);
	 escribimos el primer paquete
	 write(fd,paquete+14+sizeof(t_datagrama),datagrama.tam_dat);
	 /* escribimos todos los paquetes recibidos
	 for (i = 2; i <= num_paquetes; i++) {
		 while ((aux = pop()) == NULL)
			;
		 memcpy(&datagrama, (aux->datos+14), sizeof(t_datagrama));
		 write(fd,aux->datos+14+sizeof(t_datagrama),datagrama.tam_dat);
	 }
	 close(fd);
  }

*/   else if (paquete->datag.flags & MENSAJE_ERR)
		printf ("%s\n", paquete->datos);
	 else
		printf ("\nError. Paquete con flag no reconocido\n\n");
/*  farfree (paquete->datos);
  free (paquete);
  return 1;*/
}

/************************************************************************
 Funcion que conecta el FTP cliente con un servidor
 Devuelve:
 0 si no se ha podido conectar al servidor
 1 si se ha conectado (el servidor estar insertado en la tabla)
*************************************************************************/
void Conectar(void) {

  t_datagrama datagrama;
  t_paquete paq_rec;
  int recibido;

  clrscr();
  printf("Nombre del servidor al que conectar: ");
  scanf("%s", servidor);

  datagrama = enviar_paquete_mensaje (servidor, "", 0, MAQ_DESC, num_cliente);
  recibido = esperar_paquete_con_mascara (datagrama, "", &paq_rec,
										  R_MAQ_DESC | MENSAJE_ERR);
  if (recibido)
	 tratar_paquete (&paq_rec);
 }
/************************************************************************/

void cambiar_directorio_remoto (void) {

  t_datagrama datagrama;
  t_paquete paq_rec;
  int recibido;
  char directorio[TAM_MAX_DIRECTORIO];

  clrscr();
  printf("Nombre del nuevo directorio: ");
  scanf("%s", directorio);

  datagrama = enviar_paquete_mensaje (servidor, directorio,
									 strlen(directorio) + 1, CD, num_cliente);
  recibido = esperar_paquete_con_mascara (datagrama, "", &paq_rec,
										  R_CD | MENSAJE_ERR);
  if (recibido)
	 tratar_paquete (&paq_rec);
}



/************************************************************************/
void subir_fichero(void) {

  long tam_fich;
  int recibido;
  t_paquete paq_rec;
  t_datagrama datagrama;
  char fichero[20];

  clrscr();
  printf("Introduce el nombre del fichero: ");
  scanf("%s", fichero + sizeof (long));

  _fmode = O_BINARY;
  d_cliente.handle = open (fichero + sizeof (long), O_RDONLY);
  if (d_cliente.handle == -1){
	 printf("El fichero no se encuentra. Fichero No valido\n");
	 return;
  }
  // EL TAMAO DEL FICHERO ESTA CONTENIDO EN LOS PRIMEROS 4 BYTES DE
  // LA VARIABLE FICHERO. SEGUIDAMENTE, SE ENCUENTRA EL NOMBRE DEL FICHERO
  // A SUBIR.
  d_cliente.estado = E_SUBIENDO;
  tam_fich = filelength (d_cliente.handle);
  memcpy (fichero, (char *)(&tam_fich), sizeof (long));

  datagrama = enviar_paquete_mensaje (servidor, fichero, sizeof (long) +
					 strlen(fichero + sizeof (long)) + 1, SUBIR, num_cliente);
  recibido = esperar_paquete_con_mascara (datagrama, "", &paq_rec,
										  R_SUBIENDO | MENSAJE_ERR);
  if (recibido) {
	 printf ("Recibida ventana: %ld\n", *(long *)(((char *)&paq_rec.datos)+4));
	 tratar_paquete (&paq_rec);
  } else
	 printf ("El servidor no reponde. Transmisin cancelada\n");

  close(d_cliente.handle);
}

/************************************************************************/
void subiendo_fichero(t_paquete *paquete) {

   t_ventana ventana_actual;
   t_ventana ventana_recibida;
   int quedan_por_enviar;
   int hay_paquete;                 // Significa que ha llegado un paquete
   t_paquete paquete_recibido;      // Paquete que se recibe (en este caso,
									// debe contener una la ventana_salida
   time_t tiempo_inicio,            // Hora de inicio para contar el tiempo
		  tiempo_actual;            // Hora actual
   double dif_tiempo;               // Espacio de tiempo que ha pasado desde
									// que se envi el ltimo paquete de ventana


   memcpy (&ventana_actual, paquete->datos, sizeof (t_ventana));
   quedan_por_enviar = enviar_paquetes_de_ventana (ventana_actual,
									  d_cliente.handle, d_cliente.n_logico,
									  servidor, SUBIENDO, num_cliente);
   // Comprueba si ha finalizado el envio de todos los paqutes (pq_total).
   while (quedan_por_enviar) {

	  // Espero hasta que reciba la siguiente ventana o se pase un cierto
	  // intervalo de tiempo en el que aborto el envio del fichero.
	  dif_tiempo = 0;
	  hay_paquete = 0;
	  tiempo_inicio = time (NULL);
	  while ((!hay_paquete) && (dif_tiempo < QUANTUM_ESPERA_VENT))
	  {
		 hay_paquete = sacar_paq (&paquete_recibido);
		 // Si recibo un paquete, compruebo que no este repetido o
		 // sean paquetes con comandos incosistentes
		 if (hay_paquete) {
			memcpy (&ventana_recibida, paquete_recibido.datos, sizeof (t_ventana));
			if ((ventana_recibida.num_ventana <= ventana_actual.num_ventana) ||
				(paquete_recibido.datag.flags != R_SUBIENDO))
			   hay_paquete = 0;
		 }
		 tiempo_actual = time (NULL);
		 dif_tiempo = difftime (tiempo_actual, tiempo_inicio);
	  } // while

	  // Si NO ha llegado la ventana en el tiempo establecido, se aborta
	  // el envio del fichero
	  if (!hay_paquete) {
		 printf ("El servidor no reponde. Transmisin cancelada\n");
		 return;
	  } else {
		   printf ("Recibida ventana: %ld\n", *(long *)(((char *)&paquete_recibido.datos)+4));
		   memcpy (&ventana_actual, &ventana_recibida, sizeof (t_ventana));
		   quedan_por_enviar = enviar_paquetes_de_ventana (ventana_actual,
									d_cliente.handle, d_cliente.n_logico,
									servidor, SUBIENDO, num_cliente);
	  }
   } // while
   // Se ha enviado el fichero por completo
   printf("Fichero subido con exito\n");
}



void liberar_handle (int handle) {

   struct REGPACK reg;

   release (handle, &reg);
}



/************************************************************************
 Funcion que visualiza el menu por pantalla
*************************************************************************/
int Menu(void) {
int opcion;

 /*  clrscr();*/
  printf("--------------------------------\n");
  printf("1. Conectar a un FTP servidor.\n");
  printf("2. Listar ficheros en el servidor.\n");
  printf("3. Cambiar directorio en el servidor.\n");
  printf("4. Obtener un archivo desde el servidor.\n");
  printf("5. Subir un fichero al sevidor.\n");
  printf("6. Cerrar conexin.\n");
  printf("0. Salir.\n");

  printf("\nOpcin: ");
  scanf("%d", &opcion);

  return opcion;
}

/************************************************************************/
int main() {

  int handle,
	  opcion;


  handle = Inicializar();
  do {
	 opcion = Menu();
	 if (opcion == 1)
		 Conectar();
	 else if (num_cliente != -1)
		 switch (opcion) {
//			  case 2: Listar();
//						 break;
			  case 3: cambiar_directorio_remoto();
						 break;
//			  case 4: Recibir();
//						 break;
			  case 5: subir_fichero();
						 break;
			  case 6:
						 break;
			  default: break;
		 }
  } while (opcion != 0);

  liberar_handle (handle);
  return 0;
}