#include <math.h>
#include <time.h>
#include "red.h"

// Numero de paquetes por ventana
#define TAM_VENTANA 10
// Intervalo de tiempo mnimo
#define QUANTUM 1
// Tiempo mximo que se esta esperando para recibir un paquete de repuesta
#define QUANTUM_ESPERA_UN_PAQ (0.6 * QUANTUM)
// Tiempo mximo que se esta esperando para recibir una ventana
#define QUANTUM_ESPERA_VENT (3 * QUANTUM)
// Tiempo mximo que se espera un paquete (estado-->subiendo)
#define QUANTUM_ESPERA_SUBIENDO (0.6 * QUANTUM)
// Tiempo que se espera para desconectar a un usuario no operativo
#define QUANTUM_PARA_DESCONEXION (900 * QUANTUM)
// Tiempo que se espera para revisar las peticiones pendientes de los usuarios
#define QUANTUM_COMP_USUARIOS (0.2 * QUANTUM)


// Estructura para definir cada ventana movil
typedef struct tipo_ventana{
	long primero;       // primer elemento de la ventana
	long num_ventana;   // Numero de la ventana por envio de fichero,
						// para descartar paquetes repetidos en la cola.
	int vector[TAM_VENTANA]; // Indica si un paquete de dicha ventana ha
							 // sido recivido/enviado.
}t_ventana;


t_ventana genera_ventana_nueva(t_ventana ventana, int paq_totales);
int enviar_paquetes_de_ventana (t_ventana ventana, int handle,
								char n_logico_og[],	char n_logico_dt[],
								int flags, int num_usr);

