#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>
#include <dos.h>
#include <conio.h>
#include <alloc.h>

// Carry de flag
#define CF 1
// Devuelve la parte alta de un registro r
#define HI(r) ((r & 0xFF00) >> 8)
// Devuelve la parte baja de un registro r
#define LO(r) (r & 0x00FF)
// Tamao de una direccin fisica
#define TAM_DIR 6
// Tamao del tipo asociado a la interfaz con la tarjeta ethernet
#define TAM_TIPO 2
// Tamao que ocupan las dos direcciones fisicas y el tipo. Datos min. de
// cualquier trama ethernet
#define TAM_DIRS_TIPO (2 * TAM_DIR + TAM_TIPO)
// Tamao minimo que puede tener una trama ethernet
#define TAM_MIN_TRAMA 72
// Tamao maximo que puede tener una trama: 1526 bytes mas un pequeo margen
#define TAM_MAX_TRAMA 1600
// Nmero maximo de tramas recibidas que pueden estar en un buffer esperando
// a ser atendidas.
#define NUM_MAX_TRAMAS 30


// Tipo para almacenar la cola de paquetes entrantes
// para ser atentidos posteriormente
typedef struct tipo_buffer_ent {
	char libre;				    // Indica si se puede almacenar una trama
	char trama[TAM_MAX_TRAMA];  // Datos de la trama
} t_buffer_entr;



// Buffer de entrada de tramas
extern t_buffer_entr buffer_entr [NUM_MAX_TRAMAS];
// Indica la posicin donde se debe insertar el siguiente paquete.
extern int ins_buffer_entr;
// Indica la posicin de donde se debe sacar el siguiente paquete.
extern int sac_buffer_entr;
// Direccin fisica origen
extern char dir_origen[TAM_DIR];
// tipo para la trama
extern char *tipo;
// direccion fisica para broadcast
extern char BROAD_CAST[TAM_DIR];


char *devuelve(int registro);
void error(struct REGPACK *reg) ;
int driver_info(struct REGPACK *reg);
int get_address(int handle, char *buffer, int len, struct REGPACK *reg);
int send_pkt(char *buffer, int len, struct REGPACK *reg) ;
char *make_pkt (char dir_dest[], char dir_orig[], char tipo[],
						 char *datos, int *tamanio) ;
int set_rcv_mode(int handle, int mode, struct REGPACK *reg) ;
void interrupt receiver(int bp, int di, int si, int ds, int es, int dx, int cx,
						int bx, int ax, int ip, int cs, int flags) ;
int access_type(int if_class, int if_type, int if_number, char *type,
				int typelen, void interrupt *receiver, struct REGPACK *reg) ;
int release(int handle, struct REGPACK *reg) ;
