#include "transpor.h"

#define E_ACTIVO 1
#define E_DESCONECTADO 2
#define E_SUBIENDO 3

#define ITERACIONES_ABORTAR 2

#define MAQ_DESC     (1L)        // Servidor desconocido; pedimos su direccin
#define R_MAQ_DESC   (1L << 1)   // respuesta servidor
#define DIR 	     (1L << 2)	 // listar el directorio actual del servidor
#define R_DIR        (1L << 3)	 // respuesta al listado
#define CD 		     (1L << 4)   // cambiar directorio en el servidor
#define R_CD 	     (1L << 5)   // respuesta a cambiar directorio
#define RECIBIR 	 (1L << 6)	 // recibir un fichero desde el servidor
#define R_RECIBIR    (1L << 7)   // respuesta a recibir un fichero
#define SUBIR        (1L << 8)   // subir un fichero
#define R_SUBIENDO   (1L << 9)   // respuesta a subir un fichero
#define SUBIENDO     (1L << 10)  // subiendo los paquetes del fichero
#define BAJANDO      (1L << 11)  // bajando los paquetes del fichero
#define MENSAJE_ERR  (1L << 12)  // mensaje de error

#define MAX_USUARIOS 10

#define USUARIO_SIN_DIR "usr_s_dir"

#define TAM_MAX_DIRECTORIO 50

typedef struct tipo_usuario {
	char n_logico[TAM_MAX_NOMBRE_LOG]; // nombre logico del usuario
	int handle,     // handle del fichero donde estamos escribiendo para
					// este usuario
		estado,    // estado en el que se encuentra el usuario
		iteracion_abortar; // iteraciones que faltan para abortar

	t_ventana ventana; // ultima ventana que hemos mandado

	double tiempo_ultima_operacion; // Momento en el que el usuario ha
									// realizado la ultima operacin.
	char directorio_actual [50];
	unsigned long pq_total;        // Paquetes totales cuando se esta
								   // subiendo un fichero
} t_usuario;
