//*************************************************************************
// Se utilizar el campo aux1 de t_datagrama para enviar el numero que
// el servidor le ha otorgado a un usuario.
//*************************************************************************

#include <io.h>
#include <sys\stat.h>
#include <math.h>
#include <fcntl.h>
#include <process.h>
#include <dos.h>
#include <dir.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "ftp.h"

#define INTR 0X9    // Interrupcion del teclado - eso creo
#define TIPO 83

t_usuario usuarios[MAX_USUARIOS];

char servidor[10];        // Nombre lgico del servidor


/************************************************************************/
int Inicializar(void) {
struct REGPACK reg;
int handle,
	i;

  tipo = (char *)malloc(TAM_TIPO);
  memset(tipo, TIPO, TAM_TIPO);

  if (driver_info(&reg) == -1)
	 error(&reg);

  handle = access_type(HI(reg.r_cx), reg.r_dx, LO(reg.r_cx),
					  tipo, TAM_TIPO, (void interrupt *)receiver, &reg);
  if (handle == -1)
	  error(&reg);

  if (get_address (handle, dir_origen, TAM_DIR, &reg) == -1)
	  error(&reg);

  /* handle, mode */
  if (set_rcv_mode(handle, 3, &reg) == -1)
	 error(&reg);

  // Inicializamos el vector de usuarios a vaco
  for (i = 0; i < MAX_USUARIOS; i++)
	 usuarios[i].estado = E_DESCONECTADO;

  // Inicializamos el buffer de entrada de paquetes a vaco
  for (i = 0; i < NUM_MAX_TRAMAS; i++)
	 buffer_entr [i].libre = 1;

  return (handle);
}


/************************************************************************
 Funcion que conecta el FTP cliente con un servidor
 Devuelve:
 0 si no se ha podido conectar al servidor
 1 si se ha conectado (el servidor estar insertado en la tabla)
*************************************************************************/
void Conectar(void) {

  clrscr();
  printf ("\nServidor MOR, S.A.\nVersion 1.0 MS-DOS Copyright 28-6-00\n\n");
  printf("Nombre del servidor: ");
  scanf("%s", servidor);
  printf ("Estado del servidor: OPERATIVO\nPresione Esc para finalizar.");
  anadir_maquina (servidor, dir_origen);
  anadir_maquina (USUARIO_SIN_DIR, BROAD_CAST);
}


/*************************************************************************/
t_datagrama enviar_paquete_mensaje (char *dir_logica_dest, char *mensaje,
							 int tam_mensaje, int flag, int num_cliente){

	t_datagrama datagrama;

	strcpy (datagrama.logico_og, servidor);
	strcpy (datagrama.logico_dt, dir_logica_dest);
	datagrama.flags = flag;
	datagrama.pq_total = 1;
	datagrama.num_pq = 1;
	datagrama.tam_dat = tam_mensaje;
	datagrama.aux1 = num_cliente;
	enviar_paq (datagrama, mensaje);
	return (datagrama);
}




/*************************************************************************/
void nuevo_usuario (t_paquete *paquete) {

	int pos, aux;
//	char direccion_cliente [TAM_DIR];
//	char nombre_fichero [12];
	char mensaje_usr_rep1 [] = "Servidor en niveles mximos de operatividad. Intentelo mas tarde";
	char mensaje_usr_rep2 [] = "Ya existe un usuario con ese nombre";
	int entradas_libres = 1;


	for (pos = 0; ((pos < MAX_USUARIOS) &&
				   (usuarios[pos].estado != E_DESCONECTADO)); pos++)
		;
	if (pos == MAX_USUARIOS)
		entradas_libres = 0;

	aux = comprueba_maquina (paquete->datag.logico_og, paquete->dir_fis_orig,
							 entradas_libres);
	if (aux == 2) {
	   if (!entradas_libres)
		  // El usuario no estaba en la red y cumplia los requisitos
		  // del protocolo, pero el servidor no acepta ms usuarios
		  enviar_paquete_mensaje (paquete->datag.logico_og, mensaje_usr_rep1,
								  strlen(mensaje_usr_rep1) + 1, MENSAJE_ERR,
								  paquete->datag.aux1);
	   else {
		  // Existen entradas en la tabla de usuarios y el usuario que
		  // pretende conectarse no estaba dado de alta en la red.
		  enviar_paquete_mensaje (paquete->datag.logico_og, "", 0, R_MAQ_DESC,
								  pos);
		  // Insertarmos al usuario en la tabla de usuarios, concretemente
		  // en la posicin indicada por 'pos'.
		  strcpy(usuarios[pos].n_logico, paquete->datag.logico_og);
		  usuarios[pos].estado = E_ACTIVO;
		  usuarios[pos].tiempo_ultima_operacion = time(NULL);
		  usuarios[pos].directorio_actual[0] = '\0';
	   }
	}
	if (aux == 1)
	   // Encontrado usuario con identica dir. fisica y mismo nombre logico.
	   // Probablemente la contestacin del servidor de conexin establecida
	   // no llego al cliente y este volvio a intentarlo.
	   // Nota: en datagrama.aux1 esta el nmero(posicin) del cliente
		 enviar_paquete_mensaje (paquete->datag.logico_og, "", 0, R_MAQ_DESC,
							   paquete->datag.aux1);

	if (aux == 0) {
	  // Para enviar un paquete que notifique la imposibilidad de coneccin,
	  // se utilizar el USUARIO_SIN_DIR. Este usuario se inserta al iniciar
	  // el servidor y se utiliza para estos caso, es decir, cuando queremos
	  // enviar un paquete a un usuario que no esta en la red.
	  // Para ello, ponemos la direccin fsica de USUARIO_SIN_DIR, con la
	  // direccin fsica del usuario que se pretende conectar.
	  cambiar_dir_fis (USUARIO_SIN_DIR, paquete->dir_fis_orig);
	  // El cliente esta intentando conectarse con un nombre lgico que
	  // ya posee otro cliente en la red.
	  if (!entradas_libres)
		// El servidor no acepta ms usuarios
		enviar_paquete_mensaje (USUARIO_SIN_DIR, mensaje_usr_rep1,
								  strlen(mensaje_usr_rep1) + 1, MENSAJE_ERR,
								  paquete->datag.aux1);
	  else
		enviar_paquete_mensaje (USUARIO_SIN_DIR, mensaje_usr_rep2,
								 strlen(mensaje_usr_rep2) + 1, MENSAJE_ERR,
								 paquete->datag.aux1);

	}
}


/*************************************************************************/
void cambiar_cd (t_paquete *paquete) {

	int aux;
	char mensaje_cd_err []="Directorio no valido";

	aux = chdir (paquete->datos);
	if (aux == -1)
		enviar_paquete_mensaje (paquete->datag.logico_og, mensaje_cd_err,
								  strlen(mensaje_cd_err) + 1, MENSAJE_ERR,
								  paquete->datag.aux1);
	else {
		strcpy (usuarios [paquete->datag.aux1].directorio_actual, paquete->datos);
		enviar_paquete_mensaje (paquete->datag.logico_og, paquete->datos,
								strlen(paquete->datos) + 1, R_CD, paquete->datag.aux1);
	}
}




/*************************************************************************/
void subir_fichero (t_paquete *paquete) {

	int n_cliente,
		i;
	long tam_fich;
	int num_paq_ventana;
	char nombre_fichero[20];
	char mensaje_subir_err [] = "No es posible crear fichero en el servidor";


	memcpy (&tam_fich, paquete->datos, sizeof (long));
	strcpy (nombre_fichero, paquete->datos + sizeof (long));
	n_cliente = paquete->datag.aux1;
	usuarios[n_cliente].pq_total = ceil((long double)tam_fich / TAM_MAX_INFO);

	_fmode = O_BINARY;
	usuarios [n_cliente].handle = creat (nombre_fichero,
										 O_TRUNC | S_IREAD | S_IWRITE);
	if (usuarios [n_cliente].handle == -1)
		enviar_paquete_mensaje (paquete->datag.logico_og, mensaje_subir_err,
								strlen(mensaje_subir_err) + 1, MENSAJE_ERR,
								n_cliente);
	else {
		num_paq_ventana = (int)(ceil ((long double)tam_fich / TAM_MAX_INFO));
		num_paq_ventana = min (TAM_VENTANA,num_paq_ventana);

		for (i = 0; i < num_paq_ventana; i++)
		   usuarios [n_cliente].ventana.vector[i] = 1;
		for (; i < TAM_VENTANA; i++)
		   usuarios [n_cliente].ventana.vector[i] = 0;

		usuarios [n_cliente].ventana.primero = 0;
		usuarios [n_cliente].ventana.num_ventana = 1;
		usuarios [n_cliente].estado = E_SUBIENDO;
		usuarios [n_cliente].iteracion_abortar = ITERACIONES_ABORTAR;
		usuarios [n_cliente].tiempo_ultima_operacion = time (NULL);

		enviar_paquete_mensaje (paquete->datag.logico_og,
						 (char *)&(usuarios [n_cliente].ventana),
						 sizeof (t_ventana), R_SUBIENDO, n_cliente);
	 }
}
/**************************************************************************
   Si es el ultimo paquete que faltaba por recibir de la ventana que se
   estuviera tratando (ventana.vector[ALL] = 0), entonces se solicita
   la nueva ventana al procedimiento de la capa de transporte ventana_nueva.
****************************************************************************/
int subiendo_fichero(t_paquete *paquete){

	int i, j,
		n_cliente;

	n_cliente = paquete->datag.aux1;
	usuarios[n_cliente].tiempo_ultima_operacion = time (NULL);
	usuarios [n_cliente].iteracion_abortar = ITERACIONES_ABORTAR;
	// Ignoramos el paquete si no pertenece a la ventana o si lo estoy
	// recibiendo por 2,3... vez.
	if ((paquete->datag.num_pq < usuarios[n_cliente].ventana.primero) ||
		(!usuarios[n_cliente].ventana.vector[paquete->datag.num_pq -
									  usuarios[n_cliente].ventana.primero]))
		return (-1);

	//escribimos el paquete en el handle del usuario
	printf ("\nRecibido paq. %ld", paquete->datag.num_pq);
	lseek (usuarios[n_cliente].handle, paquete->datag.num_pq * TAM_MAX_INFO,
			 SEEK_SET);
	write(usuarios[n_cliente].handle, paquete->datos, paquete->datag.tam_dat);
	usuarios[n_cliente].ventana.vector [paquete->datag.num_pq -
						  usuarios[n_cliente].ventana.primero] = 0;

   // Comprueba que se han recibido todos los paquetes de la ventana
   for (i = 0; ((i < TAM_VENTANA) &&
				(usuarios[n_cliente].ventana.vector [i] == 0)); i++)
	  ;
   if (i == TAM_VENTANA)
   {
	 // Se han recibido todos los paquetes y se le envia al cliente la sig
	 // ventana. Si se ha recibido todo el fichero, se manda la ventana
	 // tota a cero.
	 usuarios[n_cliente].ventana = genera_ventana_nueva (usuarios[n_cliente].ventana,
										  paquete->datag.pq_total);
	 enviar_paquete_mensaje (paquete->datag.logico_og,
							 (char *)(&(usuarios[n_cliente].ventana)),
							 sizeof(t_ventana), R_SUBIENDO, n_cliente);

	 // Compruebo que han llegado todos los paquetes que forman el fichero
	 for (j = 0; ((j < TAM_VENTANA) &&
				  (usuarios[n_cliente].ventana.vector [j] == 0)); j++)
		;
	 if (j == TAM_VENTANA) {
		// El fichero esta totalmente recibido y se cierra
		usuarios[n_cliente].estado = E_ACTIVO;
		close (usuarios[n_cliente].handle);
	 }
  }
  return (0);
}



/****************************************************************************/
void comprobar_usuarios(void){

	int i, j;

	// Para todos los usuarios
	for (i = 0; i < MAX_USUARIOS; i++){
	  // Si no existe usuario en la celda, paso a examinar la sig. celda
	  if (usuarios[i].estado == E_DESCONECTADO)
		 continue;
	  // Calculo si se esta subiendo un paq. y ha pasado el quatum
	  if ((difftime(time(NULL),usuarios[i].tiempo_ultima_operacion) >
		   QUANTUM_ESPERA_SUBIENDO) && (usuarios[i].estado == E_SUBIENDO)) {
		 // Si le quedan iteraciones vuelve a mandar la ventana porque
		 // seguramente se habr perdido
		 if (usuarios[i].iteracion_abortar)
		 {
			usuarios[i].tiempo_ultima_operacion = time (NULL);
			usuarios[i].ventana = genera_ventana_nueva (usuarios[i].ventana,
														usuarios[i].pq_total);
			enviar_paquete_mensaje (usuarios[i].n_logico,
									(char *)(&(usuarios[i].ventana)),
									sizeof(t_ventana), R_SUBIENDO, i);
/*			printf ("\nEnviando ventana:   ");
			for (j = 0; j < TAM_VENTANA; j++)
			   if (usuarios[i].ventana.vector[j])
				  printf (" %2ld", j * usuarios[i].ventana.vector[j] +
											   usuarios[i].ventana.primero);*/
			// Compruebo que han llegado todos los paquetes que forman
			// el fichero
			for (j = 0; ((j < TAM_VENTANA) &&
						 (usuarios[i].ventana.vector [j] == 0)); j++)
			   ;
			if (j == TAM_VENTANA) {
			   // El fichero esta totalmente recibido y se cierra
			   usuarios[i].estado = E_ACTIVO;
			   close (usuarios[i].handle);
			} else
			   usuarios[i].iteracion_abortar--;
		 }
		 else
		 {
			// Abortamos la subida de fichero por pasar 'iteraciones_abortar'
			close (usuarios[i].handle);
			usuarios[i].estado = E_ACTIVO;
		 }
	  }
	  // Comprueba si lleva mucho tiempo sin hacer nada, y suponemos
	  // se ha desconectado
	  if (difftime(time(NULL),usuarios[i].tiempo_ultima_operacion) >
		   QUANTUM_PARA_DESCONEXION) {

		// FALTA ELIMINAR USUARIO DE RED.C (FUNCION ELIMINAR_MAQUINA) Y
		// ADEMAS ELIMINARLO DEL VECTOR USURIOS, SIN OLVIDAR LIBERAR TODOS

	  }
   }
}





/*************************************************************************/
void atender_paquete (t_paquete *paquete) {

   if (paquete->datag.flags & MAQ_DESC)
		 nuevo_usuario (paquete);
   else
   if (paquete->datag.flags & CD)
		 cambiar_cd (paquete);
   else
   if (paquete->datag.flags & SUBIR)
		 subir_fichero (paquete);
   else
   if (paquete->datag.flags & SUBIENDO)
		 subiendo_fichero (paquete);


/*   } else
	  if (datagrama.flags & DIR){
			  fich = fopen ("temp.aux", "wb");
			  if (fich == NULL)
				 printf ("Error de apertura del fichero\n");
			  existen_fich = findfirst("*.*", &dat_fich, 0);
			  while (!existen_fich)
			  {
				 printf("%s\n", dat_fich.ff_name);
				 fprintf (fich, "%s\n", dat_fich.ff_name);
				 existen_fich= findnext(&dat_fich);
			  }
			  fclose (fich);
			  datagrama.flags = R_DIR;
			  enviar_fichero (datagrama, "temp.aux");
	  }else if (datagrama.flags & RECIBIR){
		  datagrama.flags = R_RECIBIR;
		  strcpy (nombre_fichero, ((char *)paquete->datos) +
										  sizeof (t_datagrama) + TAM_DIRS_TIPO);
		  enviar_fichero (datagrama, nombre_fichero);
	  else
















				 // Lee el fichero

				 // Espero por el primer paquete
				 while ((aux = pop()) == NULL)
					 ;
				 memcpy (&datagrama, aux->datos + TAM_DIRS_TIPO, sizeof (t_datagrama));
				 num_paquetes = datagrama.PQ_total;
				 fd = open(nombre_fichero, O_CREAT | O_TRUNC | O_BINARY);
				 /* escribimos el primer paquete *
				 write(fd,aux->datos+TAM_DIRS_TIPO+sizeof(t_datagrama),datagrama.tam_dat);
				 /* escribimos todos los paquetes recibidos *
				 free (aux->datos);
				 free (aux);
				 for (i = 2; i <= num_paquetes; i++) {
					while ((aux = pop()) == NULL)
						;
					write(fd,aux->datos+TAM_DIRS_TIPO+sizeof(t_datagrama),datagrama.tam_dat);
					free (aux->datos);
					free (aux);
				 }
				 close(fd);
				 break;
				 printf ("\nError. Paquete con comando invlido.");

	farfree (paquete->datos);
	free (paquete);             */
}


/*************************************************************************/
void liberar_handle (int handle) {

	struct REGPACK reg;

	release (handle, &reg);
}



/*************************************************************************/
void chequear_peticiones (void) {

	t_paquete paquete_recibido;

	if (sacar_paq (&paquete_recibido))
	   atender_paquete (&paquete_recibido);
}


/************************************************************************/
int main() {
#define ESCAPE 27     // Codigo ascii de la tecla Esc

  int handle;
  t_datagrama datagrama;
  time_t t_comprobacion;


  handle = Inicializar ();
  Conectar ();

  t_comprobacion = time (NULL);

  do {
	chequear_peticiones ();

	if (difftime (time (NULL), t_comprobacion) > QUANTUM_COMP_USUARIOS) {
		comprobar_usuarios();
		t_comprobacion = time (NULL);
	}
  } while (!kbhit());

  liberar_handle (handle);
  return 0;
}



